package com.listviewsample;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.graphics.Typeface;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

public class ListViewSample extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        for ( int i = 0; i < 20; i++ ) {
			Object object = new Object();
			listItems.add(object);
        }
        
		final ListView list = (ListView) findViewById(R.id.list);
		adapter = new ListItemsAdapter(listItems);
		list.setAdapter(adapter);
    }
    
	private class ListItemsAdapter extends ArrayAdapter<Object> {
		public ListItemsAdapter(List<Object> items) {
			super(ListViewSample.this, android.R.layout.simple_list_item_1, items);
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder holder;

			LayoutInflater inflater = getLayoutInflater();
			convertView = inflater.inflate(R.layout.list_items, null);

			holder = new ViewHolder();
			holder.text = (TextView) convertView.findViewById(R.id.text);	

			convertView.setTag(holder);

			// Bind the data efficiently with the holder.
			holder.text.setText( "Item: " + (position+1) );
			final Typeface typeface;
			if ( (position % 2) == 0 ) {
				typeface = Typeface.defaultFromStyle (Typeface.BOLD);
				holder.text.setTextSize( 15 );
			} else {
				typeface = Typeface.defaultFromStyle (Typeface.NORMAL);
				holder.text.setTextSize( 25 );
			}
			holder.text.setTypeface( typeface );
			
			switch ( position % 6 ) {
			case 0:
				holder.text.setTextColor( 0xFFFF0000 );
				break;
			case 1:
				holder.text.setTextColor( 0xFF00FF00 );
				break;
			case 2:
				holder.text.setTextColor( 0xFF0000FF );
				break;
			case 3:
				holder.text.setTextColor( 0xFFFFFF00 );
				break;
			case 4:
				holder.text.setTextColor( 0xFF00FFFF );
				break;
			default:
				holder.text.setTextColor( 0xFFFFFFFF );
				break;
			}
			
			return convertView;
		}

		private class ViewHolder {
			TextView text;
		}
	}
    
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent msg) {
		if (keyCode == KeyEvent.KEYCODE_CAMERA) {
			return true;
        } else if (keyCode == KeyEvent.KEYCODE_CALL) {
        	return true;
		} else if (keyCode == KeyEvent.KEYCODE_BACK) {
			finish();
			return true;
		}

		return false;
	}
	
	private List<Object> listItems = new ArrayList<Object>(); 
	private ListItemsAdapter adapter = null; 
}